/*---------------------------------------------------------------------------
 * miniboard.c Ver1.1b
 * ~jf
 * for UNIX
 *
 * Last modified : 1999/4/24
 *
 * Copyright(C) 1997-99  Yuto Ikeno  All rights reserved.
 * e-mail:mew@post.co.jp
 * homepage:http://www.onbiz.net/~mew/
 *
 *-------------------------------------------------------------------------*/

/*--- Define ---*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "libstr.h"
#include "libpr.h"
#include "libcgi.h"
#include "miniboard.h"

/*--handle, address, passwd͌Ăяo֐ɂė̈Kv--*/
void getCookieUser(char **handle, char **address){

	int		count;				/*Cookie𕪊name*valuȇg*/
	char	**cname = NULL, **cvalue = NULL;	/*Cookie𕪊l*/

	count = getCookieData(&cname, &cvalue, CKNAME);

	*handle = getValueAlloc("name", cname, cvalue);
	*address = getValueAlloc("e-mail", cname, cvalue);

	freedata(cname, cvalue);

	return;
}

void setCookie( char *handle, char *mail ){

	char *expire;

	expire = getExpire( COOKIE_EXPIRE_DAYS );
	printf("Set-Cookie: %s=name=%s&e-mail=%s;" ,CKNAME, handle, mail);
	printf(" Expires=%s; path=/; Domain=%s\r\n" ,expire ,DOMAIN);

	return;
}

/*--- Main ---*/
int main(void){

	char *method;					/*--- REQUEST_METHOD ---*/
	int reload_flag = 1;
	char **name, **value;			/*--- tH[f[^擾 ---*/
	char *handle = NULL,*description = NULL,*mail = NULL;	/*--- tH[e ---*/
	char *type;					/*--- IvV ---*/
	char buffer[BUFSIZE];			/*--- obt@ ---*/
	char **comment;					/*--- obt@ ---*/
	int i;							/*--- JE^ ---*/
	int count;						/*--- tH[f[^name=valuȇg ---*/
	struct tm *gmt;					/*--- sys/time.htm\́iԎ擾j---*/
	FILE *fp;
	time_t ti;

	fp = NULL;

	ti = time(NULL);
	ti += 9*60*60;		/*GMTJST*/
	gmt = gmtime(&ti);

	method = getenv("REQUEST_METHOD");
	if(method == NULL)
		method = "Unknown";

	getCookieUser(&handle, &mail);		/*NbL[擾*/

	/*----- ݂ꍇ(POST) -----*/
	if(!strcmp(method,"POST")){

		count = getForm(&name, &value);	/*POSTf[^擾*/
		if(count == -2 || count == -1){
			fatal_error(" tH[f[^̎擾Ɏs܂B", BODY);
			freedata(name, value);
			return 1;
		}
		free(handle);
		free(mail);
		handle = getValueAlloc("handle", name, value);
		mail   = getValueAlloc("mail", name, value);
		type   = getValue("type", name, value);
		description   = getValueAlloc("description", name, value);
		if(*description != '\0')
			reload_flag = 0;
		if(!strcmp(type,"write") && reload_flag == 0){

			if( *handle == '\0'){	/*nh͂ĂȂƂ*/
				fatal_error(" nh͂Ă܂",BODY);
				freedata(name, value);
				exit(1);
			}

			comment = readFile("./miniboard.dat");
			if( comment == NULL){
				fatal_error("Could not open miniboard.dat ! [2]",BODY);
				freedata(name, value);
				exit(1);
			}

			if(TAG == 0)
				replacestring(description,"<","&lt;");


			if( (fp = fopen( "./miniboard.dat", "w" )) == NULL ){
				fatal_error("Could not open miniboard.dat ! [3]",BODY);
				freedata(name, value);
				exit(1);
			}
			if(f_lock( fileno(fp) ) == -1 ){
				fatal_error(" VXeG[łB܂AēxsĂB",BODY);
				exit(1);
			}
			if(strstr(mail,"@"))
				fprintf(fp,"%s%02d/%02d/%02d:%02d.%02d%s%s<A HREF=\"mailto:%s\">%s</A>%s%s\n",TIME_TOP,gmt->tm_mon+1,gmt->tm_mday,gmt->tm_hour,gmt->tm_min,gmt->tm_sec,TIME_BOT,MES_TOP,mail,handle,MES_BOT,description);
			else if(strstr(mail,"http://"))
				fprintf(fp,"%s%02d/%02d/%02d:%02d.%02d%s%s<A HREF=\"%s\">%s</A>%s%s\n",TIME_TOP,gmt->tm_mon+1,gmt->tm_mday,gmt->tm_hour,gmt->tm_min,gmt->tm_sec,TIME_BOT,MES_TOP,mail,handle,MES_BOT,description);
			else
				fprintf(fp,"%s%02d/%02d/%02d:%02d.%02d%s%s%s%s%s\n",TIME_TOP,gmt->tm_mon+1,gmt->tm_mday,gmt->tm_hour,gmt->tm_min,gmt->tm_sec,TIME_BOT,MES_TOP,handle,MES_BOT,description);
				
			for(i = 0; i < (MAX - 1) && *(comment + i); i++){
				if(*(comment + i))
					fputs(*(comment + i),fp);
			}

			if(f_unlock( fileno(fp) ) == -1 ){
				fatal_error(" VXeG[łB܂AēxsĂB",BODY);
				exit(1);
			}
			fclose(fp);

			freeTwoDimArray(comment);

		}else if(!strcmp(type, "home")){
			printf("Location: %s\n\n",HOME);
			freedata(name, value);
			exit(0);
		}
	}

	setCookie( handle, mail );

	printPageHeader( APTITLE );
	puts(BODY);
	puts(MAINTITLE);
	printf("  %dlines",MAX);

	if(TAG == 0)
		puts("   igslk^OF~j<BR>");
	else
		puts("   igslk^OFj<BR>");

	/*--- tH[ ---*/
	puts("<FORM METHOD=\"POST\" ACTION=\"miniboard.cgi\"><TABLE BORDER=0><TR>");
	printf("<TD NOWRAP>nh</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"handle\" VALUE=\"%s\" SIZE=30 MAXLENGTH=50></TD><TD>@</TD><TD><INPUT TYPE=HIDDEN NAME=type VALUE=write></TD>",handle);
	printf("<TR><TD NOWRAP>e-mail/URL</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"mail\" VALUE=\"%s\" SIZE=30 MAXLENGTH=100></TD><TD>@</TD><TD>@</TD>",mail);
	puts("<TR><TD NOWRAP>e</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"description\" SIZE=60 MAXLENGTH=100></TD>");
	puts("<TD><INPUT TYPE=\"SUBMIT\" VALUE=\"/XV\"></TD>");
	puts("</FORM>");

	puts("<FORM METHOD=\"POST\" ACTION=\"miniboard.cgi\">");
	puts("<TD><INPUT TYPE=\"SUBMIT\" VALUE=\"@߁@@\"></TD></TR><INPUT TYPE=\"HIDDEN\" NAME=\"type\" VALUE=\"home\">");
	puts("</FORM>");
	/*--------------------*/
	puts("</TABLE>");
	puts("<HR>\n");

	/*--- ܂ł̔ews ---*/
	if((fp = fopen("miniboard.dat","r")) == NULL){
		fatal_error("Could not open miniboard.dat ! [3]",BODY);
		exit(1);
	}

	for(i = 0; i < MAX; i++){
		if(fgets(buffer,BUFSIZE,fp) == NULL){
			if(ferror(fp))
				break;
			if(feof(fp))
				break;
		}
		fputs(buffer,stdout);
		fputs("<HR>",stdout);
	}
	fclose(fp);

	/*--- 쌠\i폜Ȃłj ---*/
	puts("</PRE><TABLE WIDTH=100%><TR><TD ALIGN=RIGHT><A HREF=\"http://www.onbiz.net/~mew/\"><B>miniBoard Ver1.1b</B></A> (Free)</TABLE>");
	/*------------------------------------------*/

	if(!strcmp(method, "POST")){
		freedata(name, value);
		free( handle );
		free( mail );
		free( description );
	}
	
	exit(0);
}